/*
 * Web Designer
 * Copyright (C) 1999-2000  LADISLAS Willhem
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author's email : zillprog@freesurf.fr
 * 
 * snailmail : 
 * LADISLAS Willhem
 * 2, rue du Serpolet
 * 95490 VAUREAL
 * FRANCE
 */

#include "common_headers.h"

/*
 * This function is used for non symetrical tags 
 */
void
insert_text_and_move_cursor (GtkWidget * widget, guint Opcode)
{

	gboolean insert = FALSE;
	int i, color = 1, x = 0;
	char *text = malloc (255);

	if (numfileopened == 0)
		return;

	lasttag_nb = Opcode;

	/*
	 * numbers under 500 are used for the function tag_insert_exec 
	 * ortherwise there is no way to differenciate tags inserted from here
	 * or from the other function --> needed to reload the last tag
	 */

	switch (Opcode)
	  {

	  case TAG_ASP_COMMENT:
		  text = "<!--  -->";
		  x = 4;
		  color = COLOR_RED;
		  break;

	  case TAG_ASP_OPEN:
		  text = "<%  %>";
		  x = 3;
		  color = COLOR_MARRON;
		  break;

	  case TAG_ASP_INCLUDE:
		  text = "<%=  %>";
		  x = 3;
		  color = COLOR_MARRON;
		  break;

	  case TAG_ASP_IF:
		  text = "<% If  %>";
		  x = 3;
		  color = COLOR_MARRON;
		  break;

	  case TAG_ASP_ENDIF:
		  text = "<% End If   %>";
		  x = 3;
		  color = COLOR_MARRON;
		  break;

	  case TAG_SSI_INCLUDE:
		  text = "<!--#include file=\"\"-->";
		  x = 4;
		  color = COLOR_MARRON;
		  break;

	  case TAG_SSI_CGI:
		  text = "<!--#exec cgi=\"\"-->";
		  x = 4;
		  color = COLOR_MARRON;
		  break;

	  case TAG_SSI_LABEL:
		  text = "<!--#label=\"\" -->";
		  x = 5;
		  color = COLOR_MARRON;
		  break;

	  case TAG_SSI_GOTO:
		  text = "<!--#goto=\"\" -->";
		  x = 5;
		  color = COLOR_MARRON;
		  break;

	  case TAG_SSI_BREAK:
		  text = "<!--#break=\"\" -->";
		  x = 5;
		  color = COLOR_MARRON;
		  break;

	  }

	/*
	 * for an "intelligent" behavior  -> when text is highlighted the tags are 
	 * putted on its left and right 
	 */
	if (GTK_EDITABLE (sheet[curfile].text)->has_selection == 1)
	  {
		  gtk_editable_cut_clipboard (GTK_EDITABLE (sheet[curfile].text));
		  insert = TRUE;
	  }

	gtk_text_set_point (GTK_TEXT (sheet[curfile].text),
	gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

	switch (color)
	  {
	  case COLOR_RED:
		  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, (GdkColor *) & red, NULL, text, strlen (text));
		  break;

	  case COLOR_MARRON:
		  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &marron, NULL, text, strlen (text));
		  break;
	  }

	i = gtk_text_get_point (GTK_TEXT (sheet[curfile].text));

	gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), i - x);

	if (insert)
		gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));

	if (sheet[curfile].saved == TRUE)
		sheet[curfile].saved = FALSE;

}
